/***************************************************************************
*   Copyright (C) 2006 by Ales Zamuda                                     *
*   ales.zamuda@uni-mb.si                                                 *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef DREVO_MATRIKA_H
#define DREVO_MATRIKA_H

namespace drevo {
	//matrika homogene koordinate v 3D
	/*!
	 * \brief opučena koda za matriko
	 * @author Ales Zamuda <ales.zamuda@uni-mb.si>
	 */
	class Matrika {
	public:
		/**
		 * Tvori novo matriko brez inicializacije.
		 * @return
		 */
		Matrika();
		~Matrika();

		/**
		 * Zmnoži elemente matrike s skalarjem.
		 * @param skalar
		 */
		void operator*=( const float &skalar );

	public:
		/**
		 * Elementi matrike, predstavljeni na več načinov.
		 */
		union {
			struct {
				float
				a11, a21, a31, a41,
				a12, a22, a32, a42,
				a13, a23, a33, a43,
				a14, a24, a34, a44;
			};
			float el[ 16 ];
			float m4x4[ 4 ][ 4 ];
		};
	};
}
#endif
