/***************************************************************************
 *   Copyright (C) 2006 by Ales Zamuda                                     *
 *   ales.zamuda@uni-mb.si                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DREVO_PRESEK_H
#define DREVO_PRESEK_H

#include "tocka.h"

namespace drevo {
	/**
	 * \brief točke preseka veje za C0 zveznost
	 * @author Ales Zamuda <ales.zamuda@uni-mb.si>
	 */
	class Presek {
	public:
		/**
		 * Ustvari neinicializiran objekt.
		 * @return
		 */
		Presek();

		~Presek();

		/**
		 * Kopira presek, ustvari globoko kopijo.
		 * @param p
		 * @return
		 */
		Presek(const Presek& p) {
			stTock = p.stTock;
			for (int i = 0; i < stTock; i++)
				tocke[i] = p.tocke[i];
		}

		/**
		 * Priredi nov presek, ustvari globoko kopijo.
		 * @param p
		 * @return
		 */
		Presek& operator=(const Presek& p) {
			this->stTock = p.stTock;
			for (int i = 0; i < stTock; i++)
				tocke[i] = p.tocke[i];
			return *this;
		}

	public:
		/** Število točk v preseku. */
		int stTock;
		/** Točke preseka, jih je lahko do 16.*/
		Tocka tocke[16];
	};
}
#endif
