#ifndef ECOSYSTEM_RENDER_LEVEL_OF_DETAIL_H
#define ECOSYSTEM_RENDER_LEVEL_OF_DETAIL_H

#include "tocka.h"

namespace ecosystem {
	namespace render {
		/*!
		 * \brief določanje stopnje LOD
		 * @author Aleš Zamuda (ales.zamuda@uni-mb.si)
		 */
		class CLevelOfDetail {
		public:
			/*!
			 * Postavi položaj kamere.
			 * @param cameraPosition nov položaj kamere
			 */
			void setCameraPosition(drevo::Tocka &cameraPosition);
			/*!
			 * Iz razdalje od kamere do podane točko določi stopnjo poenostavljanja geometrije.
			 * Poenostavitev je max. pri 10.
			 * @param objectPosition lokacija objekta
			 * @return stopnja LOD
			 */
			int getLODcase(const drevo::Tocka& objectPosition) const;

		private:
			/*!
			 * Trenutni položaj kamere.
			 */
			drevo::Tocka cameraPosition;
		};
	}//namespace render
}//namespace ecosystem
#endif // ECOSYSTEM_RENDER_LEVEL_OF_DETAIL_H
