#ifndef ECOSYSTEM_DATA_INCLINATION_FACTORY_H
#define ECOSYSTEM_DATA_INCLINATION_FACTORY_H

#include <vector>
#include "terraindata.h"

namespace ecosystem {
	namespace data {
		/*!
		 * \brief izračun naklona
		 *
		 * Tovarna za izračun inklinacije.
		 * Iz že prej dobljenih normal vzame komponento y in jo odšteje od 1.
		 * @author Aleš Zamuda (ales.zamuda@uni-mb.si)
		 */
		class CInclinationFactory {
		public:
			/*!
			 * Ustvari objekt in shrani povezavo na CTerrainData
			 * @param terrainData razred z vsemi faktorji terena
			 */
			CInclinationFactory(CTerrainData &terrainData);
			/*!
			 * Destruktor, ne naredi nič
			 */
			~CInclinationFactory(void);

			/*!
			 * Iz normale izračuna naklon.
			 * Naklon je enak 1-normala.y
			 */
			void buildInclination();

		private:
			/*!
			 * Shranjena povezava na faktorje terena, kamor shranjujemo izračunano inklinacijo.
			 */
			CTerrainData &terrainData;
		};
	}
}
#endif // NATURE_DATA_INCLINATION_FACTORY_H
