#include "terrainnormalsfactory.h"

using namespace ecosystem::data;

CTerrainNormalsFactory::CTerrainNormalsFactory(CTerrainData &terrainData) : terrainData(terrainData) {}

CTerrainNormalsFactory::~CTerrainNormalsFactory(void) {}

void CTerrainNormalsFactory::buildTriangleNormals() {
	int x,y;
	/// index array of triangle vertices:
	CTerrainData::TerrainVertexData *pTerrainVertexDataPtr = terrainData.pTerrainVertexData;
	for (y=0; y<terrainData.stTockY-1; y++) {
		int row = y*terrainData.stTockX;
		for (x=0; x<terrainData.stTockX-1; x++) {
			int base = row+x;
			/// we calculate normal of the point using its two successive neighbours
			drevo::Tocka &v1 = pTerrainVertexDataPtr[base].pos;
			drevo::Tocka &v2 = pTerrainVertexDataPtr[base+terrainData.stTockX].pos;
			drevo::Tocka &v3 = pTerrainVertexDataPtr[base+1].pos;

			/// set this point's normal, let normals point out of object
			terrainData.terrainNormals[base] = getNormal(v1,v3,v2);
		}
	}
}//CTerrainNormalsFactory::buildTriangleNormals

drevo::Tocka CTerrainNormalsFactory::getNormal(drevo::Tocka &v1,
        drevo::Tocka &v2,
        drevo::Tocka &v3) {
	drevo::Tocka r1,r2,n;
	r1 = v1;
	r1=r1-v2;/// v1-v2
	r2 = v3, r2=r2-v2;/// v3-v2

	n=drevo::Tocka::vektorskiProd(r1,r2);
	n.normalize();

	return n;
}//CTerrainNormalsFactory::getNormal
