#include "pogoj.h"
#include "randomgenerator.h"
#ifdef _WIN32
#define _USE_MATH_DEFINES
#endif
#include <math.h>

using namespace ecosystem::simulationEntities;

bool CPogoj::umreZaradiNeugodnegaPogoja(unsigned long long &randomSmrtiZaradiNeugodnegaPogoja, float pogojTukaj) {
	float odstopanjeOdPotrebe = fabs(potreba-pogojTukaj);

	if (odstopanjeOdPotrebe <= toleriranaSprememba)
		return false;

	return CRandomGenerator::randomGenerator(100000, randomSmrtiZaradiNeugodnegaPogoja)/100000.f < verjetnostSmrtiObNeugodnosti;
}//CPogoj::umreZaradiNeugodnegaPogoja

CPogoj::CPogoj(float potreba,
               float toleriranaSprememba,
               float verjetnostSmrtiObNeugodnosti,
               float slabVplivNaHitrostRasti) {
	this->potreba = potreba;
	this->toleriranaSprememba = toleriranaSprememba;
	this->verjetnostSmrtiObNeugodnosti = verjetnostSmrtiObNeugodnosti;
	this->slabVplivNaHitrostRasti = slabVplivNaHitrostRasti;
}//CPogoj::CPogoj

float CPogoj::getFaktorRasti(float pogojTukaj) {
	float faktor = 1.0f;

	/// želi vlago, sonce,... torej prodornost raste, če je več vlage, sonca,...
	if ((potreba - pogojTukaj) > toleriranaSprememba) {
		float val=fabs(potreba - pogojTukaj)*slabVplivNaHitrostRasti;
		faktor -= 1.0f>val?1.0f:val;//max
	}

	return faktor;
}//CPogoj::getFaktorRasti
