#ifndef ECOSYSTEM_SIMULATION_RANDOMGENERATOR_H
#define ECOSYSTEM_SIMULATION_RANDOMGENERATOR_H

namespace ecosystem {
	/*!
	* \brief random generator
	*
	*
	*@author Aleš Zamuda (ales.zamuda@uni-mb.si)
	*/
	class CRandomGenerator {
	public:
		/**
		 * Ustvari nov random generator, nič se ni treba inicializirati.
		 * @return
		 */
		CRandomGenerator();
		/**
		 * Odstrani objekt.
		 */
		~CRandomGenerator();
		/**
		 * Vrne naslednje psevdo-naključno število po algoritmu LCG.
		 * Dobljeno seme spremenimo.
		 *
		 * @param razpon razpon, v katerem naj se vrne novo psevdo-naključno število
		 * @param RNi seme za generator, ki ga spremenimo ob izhodu
		 * @return psevdo-naključno število, v podanem razponu od (0..razpon)
		 */
		static unsigned int randomGenerator(int razpon, unsigned long long &RNi);

	private:
	};
}//namespace ecosystem
#endif
