#include "sejaleckjerkolirastlinnateren.h"
#include "randomgenerator.h"

using namespace ecosystem;

unsigned long long ecosystem::CSejalecKjerkoliRastlinNaTeren::randomPozicijeNovihRastlinKjerkoli = 1;

CSejalecKjerkoliRastlinNaTeren::CSejalecKjerkoliRastlinNaTeren(data::CTerrainData &terrainData,
        std::vector<Tocka2i> &pozicije2d, std::vector<drevo::Tocka> &pozicije3d) :
terrainData(terrainData), pozicije2d(pozicije2d), pozicije3d(pozicije3d) {}//CSejalecKjerkoliRastlinNaTeren::CSejalecKjerkoliRastlinNaTeren

void CSejalecKjerkoliRastlinNaTeren::dodajRastlineKjerkoli(int stRastlinRastocihKjerkoli) {
	Tocka2i pozicija2d;
	drevo::Tocka pozicija3d;
	for (int i = 0; i < stRastlinRastocihKjerkoli; i++) {
		dolociPozicijoNoveRastline2Dkjerkoli(pozicija2d);
		/// določimo še 3d pozicijo, saj je 2d pozicija tukaj vedno x>=0!
		terrainData.dolociPozicijoNoveRastline3D(pozicija2d, pozicija3d);
		dodajRastlinoVSeznama(pozicija2d, pozicija3d);
	}
}//CSejalecKjerkoliRastlinNaTeren::dodajRastlineKjerkoli

void CSejalecKjerkoliRastlinNaTeren::dolociPozicijoNoveRastline2Dkjerkoli(Tocka2i &pozicija2d) {
	int maxIndex = (int)terrainData.nonWaterIndexes.size();
	int indexNonwaterSeznam = CRandomGenerator::randomGenerator(maxIndex, randomPozicijeNovihRastlinKjerkoli);
	int indexGrid = terrainData.nonWaterIndexes[indexNonwaterSeznam];

	pozicija2d.y = indexGrid / terrainData.stTockX;
	pozicija2d.x = (indexGrid - pozicija2d.y*terrainData.stTockX);
}//CSejalecKjerkoliRastlinNaTeren::dolociPozicijoNoveRastline2Dkjerkoli

void CSejalecKjerkoliRastlinNaTeren::dodajRastlinoVSeznama(const Tocka2i &pozicija2d, const drevo::Tocka &pozicija3d) {
	if (terrainData.jeNadVodo(pozicija3d)) {
		pozicije2d.push_back(pozicija2d);
		pozicije3d.push_back(pozicija3d);
	}
}//CSejalecKjerkoliRastlinNaTeren::dodajRastlinoVSeznama
