#include "entitiesstatistics.h"

using namespace ecosystem::statistics;

CEntitiesStatistics::CEntitiesStatistics() {
	stTrenutnoZivih = 0;
	umrliZaradiDominiranosti = 0;
	umrliSkupaj = 0;
	sumRenderTime=0;
	sumSimmTime=0;
}//CEntitiesStatistics::CEntitiesStatistics

CEntitiesStatistics::~CEntitiesStatistics() {
	for (int i = 0; i < (int)grafiStevilaRastlin.size(); i++)
		delete grafiStevilaRastlin[i];
	for (int i = 0; i < (int)grafiStevilaUpodobljenihRastlin.size(); i++)
		delete grafiStevilaUpodobljenihRastlin[i];
}

void CEntitiesStatistics::setStTrenutnoZivih(int stTrenutnoZivih) {
	this->stTrenutnoZivih = stTrenutnoZivih;
}//CEntitiesStatistics::setStTrenutnoZivih

std::string CEntitiesStatistics::getLogText() {
	return logText;
}

void CEntitiesStatistics::dodajSmrtZaradiDominiranosti() {
	umrliZaradiDominiranosti++;
	umrliSkupaj++;
}//CEntitiesStatistics::dodajSmrtZaradiDominiranosti

void CEntitiesStatistics::dodajSmrtOstalo() {
	umrliOstalo++;
	umrliSkupaj++;
}//CEntitiesStatistics::dodajSmrtOstalo

std::vector<drevo::Krivulja*>* CEntitiesStatistics::getGrafiStevilaRastlin() {
	return &grafiStevilaRastlin;
}

std::vector<drevo::Krivulja*>* CEntitiesStatistics::getGrafiStevilaUpodobljenihRastlin() {
	return &grafiStevilaUpodobljenihRastlin;
}

void CEntitiesStatistics::addLiveSpecies(const std::vector<int> &stevilaRastlin) {
	///po možnosti razširimo število grafov na sliki
	while ((int)grafiStevilaRastlin.size() < (int)stevilaRastlin.size())
		grafiStevilaRastlin.push_back(new drevo::Krivulja);

	int vseSkupaj=0;
	///shranimo nova števila
	for (int i = 0; i < (int)stevilaRastlin.size(); i++) {
		drevo::Tocka2D tocka;
		tocka.x=(int)grafiStevilaRastlin[i]->kontrolneTocke.size();
		tocka.y=stevilaRastlin[i];
		vseSkupaj+=stevilaRastlin[i];
		grafiStevilaRastlin[i]->kontrolneTocke.push_back(tocka);
	}
	setStTrenutnoZivih(vseSkupaj);
}

void CEntitiesStatistics::addRenderedSpecies(const std::vector<int> &stevilaRastlin) {
	///po možnosti razširimo število grafov na sliki
	while ((int)grafiStevilaUpodobljenihRastlin.size() < (int)stevilaRastlin.size())
		grafiStevilaUpodobljenihRastlin.push_back(new drevo::Krivulja);

	///shranimo nova števila
	for (int i = 0; i < (int)stevilaRastlin.size(); i++) {
		drevo::Tocka2D tocka;
		tocka.x=(int)grafiStevilaUpodobljenihRastlin[i]->kontrolneTocke.size();
		tocka.y=stevilaRastlin[i];
		grafiStevilaUpodobljenihRastlin[i]->kontrolneTocke.push_back(tocka);
	}
}

#include <sstream>
void CEntitiesStatistics::saveSimulationRutinesTimings(int stepNr, int casOstalo, int casDodajal, int casZrastel, int casPobijal, int casPobijanjaDominiranihRastlin) {
	sumRenderTime+=casOstalo;
	sumSimmTime+=casDodajal+casZrastel+casPobijal;

	std::stringstream convert;
	convert << "@" << stepNr <<":";
	convert << " time(render_all)="<<sumRenderTime;
	convert << " time(simm_all)="<<sumSimmTime << " || ";
	convert << " time(render)="<<casOstalo;
	convert << " time(dodaj)="<<casDodajal;
	convert << " time(zrasti)="<<casZrastel;
	convert << " time(pobij)="<<casPobijal;
	convert << " time(pobij_dominir)="<<casPobijanjaDominiranihRastlin << " || ";
	convert << " nrPlants="<<stTrenutnoZivih;
	logText = convert.str();
}
