/***************************************************************************
*   Copyright (C) 2006 by Ales Zamuda                                     *
*   ales.zamuda@uni-mb.si                                                 *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include <QApplication>
#include <QTranslator>
#include <QString>
#include <QLocale>
#include <QSplashScreen>

#include "mainwindow.h"

/**
 * Kreira:
 * -aplikacijo,
 * -prevajalca jezikov za GUI,
 * -splash screen,
 * -glavno okno aplikacije,
 * -prikaže glavno okno,
 * -skrije splash screen, ga pobriše
 * -požene event loop za mainwindow (sloti/signali)
 *
 * @param argc št. parametrov za aplikacijo
 * @param argv parametri od OS
 * @return vrne izhod od app.exec
 */
int main( int argc, char ** argv ) {
	QApplication app( argc, argv );

	/// koda za transliranje v druge jezike
	QString locale = QLocale::system().name();
	QTranslator translator;
	translator.load(QString(":/gui/translations/qdrevo_") + locale);
	app.installTranslator(&translator);

	/// koda za splashscreen
	QPixmap pixmap(":/gui/icons/icons/splash.png");
	QSplashScreen *splash = new QSplashScreen(pixmap);
	splash->show();
// 	splash->showMessage("Loaded modules");
// 	app.processEvents();

	/// prikažemo mainwindow, povežemo signale/slote
	gui::MainWindow mainWindow;
	mainWindow.show();

	///skrijemo splash in ga uničimo
	splash->finish(&mainWindow);
	delete splash;

	/// poženemo eventloop
	return app.exec();
}
