/***************************************************************************
 *   Copyright (C) 2006 by Ales Zamuda                                     *
 *   ales.zamuda@uni-mb.si                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "randomgeneratorseedseditor.h"
#include <QLineEdit>
using namespace gui;

RandomGeneratorSeedsEditor::RandomGeneratorSeedsEditor(QWidget* parent)
		: QDialog(parent) {
	setupUi(this);
}

RandomGeneratorSeedsEditor::~RandomGeneratorSeedsEditor() {}

/*$SPECIALIZATION$*/
void RandomGeneratorSeedsEditor::reject() {
	QDialog::reject();
}

void RandomGeneratorSeedsEditor::accept() {
	std::vector<unsigned long long> seeds;

	seeds.push_back(randomGrowClose->text().toULongLong());
	seeds.push_back(randomChooseNearPlant->text().toULongLong());
	seeds.push_back(randomChooseNewPlantGrowSide->text().toULongLong());
	seeds.push_back(randomPositionOfNewPlantsAnywhere->text().toULongLong());
	seeds.push_back(random3dPositionOfNewPlantsI->text().toULongLong());
	seeds.push_back(random3dpositionsOfNewPlantsJ->text().toULongLong());
	seeds.push_back(randomDeathBecauseOfBeingDominated->text().toULongLong());
	seeds.push_back(randomDeathBecauseOfBadHeight->text().toULongLong());
	seeds.push_back(randomDeathBecauseOfBadMoisture->text().toULongLong());
	seeds.push_back(randomDeathBecauseOfBadSunniness->text().toULongLong());
	seeds.push_back(randomDeathBecauseOfBadWindiness->text().toULongLong());
	seeds.push_back(randomDeathBecauseOfBadSlope->text().toULongLong());
	seeds.push_back(randomTimeOfDeath->text().toULongLong());

	emit updateSeeds(seeds);

	QDialog::accept();
}

void RandomGeneratorSeedsEditor::setSeeds(const std::vector<unsigned long long>& seeds) {
	int i = 0;
	randomGrowClose->setText(QString("%1").arg(seeds[i++]));
	randomChooseNearPlant->setText(QString("%1").arg(seeds[i++]));
	randomChooseNewPlantGrowSide->setText(QString("%1").arg(seeds[i++]));
	randomPositionOfNewPlantsAnywhere->setText(QString("%1").arg(seeds[i++]));
	random3dPositionOfNewPlantsI->setText(QString("%1").arg(seeds[i++]));
	random3dpositionsOfNewPlantsJ->setText(QString("%1").arg(seeds[i++]));
	randomDeathBecauseOfBeingDominated->setText(QString("%1").arg(seeds[i++]));
	randomDeathBecauseOfBadHeight->setText(QString("%1").arg(seeds[i++]));
	randomDeathBecauseOfBadMoisture->setText(QString("%1").arg(seeds[i++]));
	randomDeathBecauseOfBadSunniness->setText(QString("%1").arg(seeds[i++]));
	randomDeathBecauseOfBadWindiness->setText(QString("%1").arg(seeds[i++]));
	randomDeathBecauseOfBadSlope->setText(QString("%1").arg(seeds[i++]));
	randomTimeOfDeath->setText(QString("%1").arg(seeds[i++]));
}
