/***************************************************************************
 *   Copyright (C) 2006 by Ales Zamuda                                     *
 *   ales.zamuda@uni-mb.si                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef RANDOMGENERATORSEEDSEDITOR_H
#define RANDOMGENERATORSEEDSEDITOR_H

#include "ui_randomgeneratorseedseditor.h"

#include <QDialog>
#include <vector>
namespace gui {
	/**
	 * Omogoča nastavljanje in opazovanje random generatorjev v simulaciji.
	 */
	class RandomGeneratorSeedsEditor : public QDialog, protected Ui::RandomGeneratorSeedsEditor {
		Q_OBJECT

	public:
		/**
		 * Kreira dialog
		 * @param parent očetovski objekt
		 */
		RandomGeneratorSeedsEditor(QWidget *parent);
		/**
		 * Pobriše dialog
		 */
		~RandomGeneratorSeedsEditor();
	signals:
		void updateSeeds(const std::vector<unsigned long long>&);

	public slots:
		void setSeeds(const std::vector<unsigned long long>& seeds);

	protected slots:
		/**
		 * Kliknemo OK
		 */
		virtual void          reject();
		/**
		 * Kliknemo Cancel
		 */
		virtual void          accept();
	};
}
#endif
