/***************************************************************************
 *   Copyright (C) 2006 by Ales Zamuda                                     *
 *   ales.zamuda@uni-mb.si                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "viewhandler.h"

#include "drevo.h"
#include "render/ecosystemrender.h"

namespace gui {

	namespace actionhandling {

		ViewHandler::ViewHandler(QObject *parent, ecosystem::render::EcosystemRender * model)
				: QObject(parent), model(model) {}

		ViewHandler::~ViewHandler() {}

		void ViewHandler::actionShow_ecosystem() {
			model->toggleSingleRender();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_leaves(){
			model->getIzbranoDrevo()->pdPrepared.listi=!model->getIzbranoDrevo()->pdPrepared.listi;
			emit forceRepaint();
		}

		void ViewHandler::actionColour_uppon(){
			model->getIzbranoDrevo()->pogled.colorMonopodial=!model->getIzbranoDrevo()->pogled.colorMonopodial;
			emit forceRepaint();
		}

		void ViewHandler::actionRender_wireframe(){
			if (model->isSingleRender()) {
				model->getIzbranoDrevo()->pogled.wireframe=!model->getIzbranoDrevo()->pogled.wireframe;
			} else {
				model->toggleWireframe();
			}
			emit forceRepaint();
		}

		void ViewHandler::actionHigh_quality_rendering_more_polygons(){
			model->getIzbranoDrevo()->pogled.highQualityRendering=!model->getIzbranoDrevo()->pogled.highQualityRendering;
			emit forceRepaint();
		}

		void ViewHandler::actionLighting_enabled(){
			model->toggleLightingEnabled();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_background_sky(){
			///kateri je pravi?
			model->getIzbranoDrevo()->pogled.backgroundSky=!model->getIzbranoDrevo()->pogled.backgroundSky;
			model->toggleDisplaySky();
			emit forceRepaint();
		}

		void ViewHandler::actionShow_frame_rate(){
			model->toggleShowFPS();
		}

		void ViewHandler::actionDo_not_draw_trees_ecosystem_mode(){
			model->toggleDoNotDrawTrees();
			emit forceRepaint();
		}

		void ViewHandler::actionDo_not_refresh_display_only_run_simulation_ecosystem_mode(){
			model->toggleDoNotRefreshDisplay();
			emit forceRepaint();
		}

		void ViewHandler::actionShow_ecologic_neighborhood_ecosystem_mode(){
			model->toggleShowNeighborHood();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_terrain_normals(){
			model->toggleDisplayTerrainNormals();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_terrain_inclination(){
			model->toggleDisplayTerrainInclination();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_terrain_moisture(){
			model->toggleDisplayTerrainMoisture();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_terrain_sunniness(){
			model->toggleDisplayTerrainSunniness();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_terrain_windiness(){
			model->toggleDisplayTerrainWindiness();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_terrain_land_markings_S_N_E_W(){
			model->toggleDisplayLandMarkings();
			emit forceRepaint();
		}

		void ViewHandler::actionDisplay_sun() {
			model->toggleDisplaySun();
			emit forceRepaint();
		}
	}

}
